diff -urN -X /home/leigh/.diffex linuxppc_2_4_devel/arch/ppc/boot/prep/head.S linuxppc_2_4_devel-local/arch/ppc/boot/prep/head.S
--- linuxppc_2_4_devel/arch/ppc/boot/prep/head.S	Tue Jul  9 19:43:18 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/prep/head.S	Thu Jul 11 18:07:31 2002
@@ -18,6 +18,12 @@
  *      Jump to the kernel entry
  *            -- Cort
  */
+
+#define CMD_BUF_LEN	256
+	.globl	cmd_buf		/* cmd_buf is here so that it can easily */
+cmd_buf:			/* be modified by an external tool       */
+	.space	CMD_BUF_LEN,0
+
 	.globl	start
 start:
 	bl	start_
@@ -44,8 +50,8 @@
 	mtmsr	r3
 
 	/* compute the size of the whole image in words. */
-	lis	r4,start@h
-	ori	r4,r4,start@l
+	lis	r4,cmd_buf@h
+	ori	r4,r4,cmd_buf@l
 	lis	r5,end@h
 	ori	r5,r5,end@l
 	addi	r5,r5,3		/* round up */
@@ -56,7 +62,7 @@
 	/* check if we need to relocate ourselves to the link addr or were
 	 * we loaded there to begin with -- Cort */
 	mflr	r3
-	subi	r3,r3,4		/* we get the nip, not the ip of the branch */
+	subi	r3,r3,CMD_BUF_LEN+4	/* adjust nip->ip, + cmd_buf length */
 	mr	r8,r3
 	cmp	0,r3,r4
 	beq	start_ldr	/* If 0, we don't need to relocate */
@@ -64,11 +70,11 @@
  * no matter where we're loaded, move ourselves to -Ttext address
  */
 relocate:
-	mflr	r3		/* Compute code bias */
-	subi	r3,r3,4
+	mflr	r3			/* Compute code bias */
+	subi	r3,r3,CMD_BUF_LEN+4	/* adjust nip->ip, + cmd_buf length */
 	mr	r8,r3
-	lis	r4,start@h
-	ori	r4,r4,start@l
+	lis	r4,cmd_buf@h
+	ori	r4,r4,cmd_buf@l
 	mr	r5,r7		/* Get the # of longwords again */
 	mtctr	r5		/* Setup for loop */
 	li	r6,0
diff -urN -X /home/leigh/.diffex linuxppc_2_4_devel/arch/ppc/boot/prep/misc.c linuxppc_2_4_devel-local/arch/ppc/boot/prep/misc.c
--- linuxppc_2_4_devel/arch/ppc/boot/prep/misc.c	Tue Jul  9 19:43:15 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/prep/misc.c	Thu Jul 11 18:30:18 2002
@@ -40,13 +40,7 @@
 extern char __ramdisk_begin, __ramdisk_end;
 extern char _end[];
 
-#ifdef CONFIG_CMDLINE
-#define CMDLINE CONFIG_CMDLINE
-#else
-#define CMDLINE ""
-#endif
-char cmd_preset[] = CMDLINE;
-char cmd_buf[256];
+extern char cmd_buf[256];
 char *cmd_line = cmd_buf;
 
 int keyb_present = 1;	/* keyboard controller is present by default */
@@ -275,7 +269,6 @@
 
 	puts("\nLinux/PPC load: ");
 	cp = cmd_line;
-	memcpy (cmd_line, cmd_preset, sizeof(cmd_preset));
 	while ( *cp )
 		putc(*cp++);
 	while (timer++ < 5*1000) {
diff -urN -X /home/leigh/.diffex linuxppc_2_4_devel/arch/ppc/boot/utils/mkprep.c linuxppc_2_4_devel-local/arch/ppc/boot/utils/mkprep.c
--- linuxppc_2_4_devel/arch/ppc/boot/utils/mkprep.c	Tue Jul  9 19:43:25 2002
+++ linuxppc_2_4_devel-local/arch/ppc/boot/utils/mkprep.c	Thu Jul 11 18:07:31 2002
@@ -165,10 +165,10 @@
  
   /* set entry point and boot image size skipping over elf header */
 #ifdef __i386__
-  *entry = 0x400/*+65536*/;
+  *entry = 0x500/*+65536*/;
   *length = info.st_size-elfhdr_size+0x400;
 #else
-  *entry = cpu_to_le32(0x400/*+65536*/);
+  *entry = cpu_to_le32(0x500/*+65536*/);
   *length = cpu_to_le32(info.st_size-elfhdr_size+0x400);
 #endif /* __i386__ */
 

